#include "interval.h"
#include "bondbox.h"
//*********************************************************************
bondbox::bondbox ():box(2)
{	inside=0;couleur=0;passeur=NULL; distance=0;

}
//--------------------------------------------------------------
bondbox::bondbox (int dim1):box(dim1)
{	inside=0;couleur=0;passeur=NULL; distance=0;}
//----------------------------------------------------------------------
bondbox::bondbox (bondbox &v):box(v)
{	if (this == &v) return;
    for (int i=1;i<=n;i++)	{left[i]=v.left[i];right[i]=v.right[i];}
	inside	=v.inside;	couleur	=v.couleur;
}
//----------------------------------------------------------------------
bondbox::~bondbox () {	delete [] data;}
//------------------------------------------------------------------------

//*********************************************************************
//******************    FUNCTIONS MEMBRES     *************************
//*********************************************************************
void bondbox::operator= (bondbox& v)
{	 if (this == &v) return;
	 delete [] data;
	 dim=v.dim;
	 data=new interval[dim];
	 for (int k=1; k<=dim; k++) (*this)[k]=v[k];
         for (int i=1;i<=n;i++) {left [i]=v.left [i];right[i]=v.right[i];}
         inside=v.inside;	couleur=v.couleur;
}


//----------------------------------------------------------------------
//*********************************************************************
//******************    FONCTION NON MEMBRES     **********************
//*********************************************************************
//----------------------------------------------------------------------

void Bisect(bondbox& x, bondbox& x1, bondbox& x2, box& V)
	{	BisectAlong(x,x1,x2,AxePrincipal(x,V));	}
//----------------------------------------------------------------------
bool VoisinLeftRight(box& X1,box& X2,int i)
{	bool a=true;
	if (Sup(X1[i])!=Inf(X2[i])) 
		return FALSE;
	for (int k=1;k<=n;k++)
		{ 	interval X1k=X1[k];
			interval X2k=X2[k];
			a=OverLap(X1k,X2k);
                        if ((k!=i)&&(!a)) return false;
		}
        return true;
}
//----------------------------------------------------------------------
void BisectAlong (bondbox& X, bondbox& X1, bondbox& X2, int i)
{
        X1=X;X2=X;
	double mx = Center(X[i]);
	(X1[i]).sup=mx;
        (X2[i]).inf=mx;
	for (int k=1;k<=n;k++)
	{	if (k==i)
                {
                        X1.right[k].DeleteAll (false);
                        X2.left [k].DeleteAll (false);
			X1.right[k].Push(&X2);		X2.left [k].Push(&X1);
			bondbox *pY = (bondbox*) (X.left[k]).GetFirst ();
			while (pY != NULL)
                        {
                                (pY->right[k]).RemoveInTheList(&X);	(pY->right[k]).Push(&X1);
				pY = (bondbox*) (X.left[k]).GetNext ();
			}
			pY = (bondbox*) (X.right[k]).GetFirst ();
			while (pY != NULL)
                        {
                                (pY->left[k]).RemoveInTheList(&X);	(pY->left[k]).Push(&X2);
				pY = (bondbox*) (X.right[k]).GetNext ();
                        }
		}
		else
                {
                        bondbox *pY = (bondbox*) (X.left[k]).GetFirst ();
			while (pY != NULL)
                        {
                                (pY->right[k]).RemoveInTheList(&X);
				if (VoisinLeftRight(*pY,X1,k))	(pY->right[k]).Push(&X1);
				else 	(X1.left[k]).RemoveInTheList(pY);
				if (VoisinLeftRight(*pY,X2,k))	(pY->right[k]).Push(&X2);
				else (X2.left[k]).RemoveInTheList(pY);
				pY = (bondbox*) (X.left[k]).GetNext ();
			}
			pY= (bondbox*) (X.right[k]).GetFirst ();
			while (pY!=NULL)
                        {
                                (pY->left[k]).RemoveInTheList(&X);
				if (VoisinLeftRight(X1,*pY,k))	(pY->left[k]).Push(&X1);
				else (X1.right[k]).RemoveInTheList(pY);
				if (VoisinLeftRight(X2,*pY,k))	(pY->left[k]).Push(&X2);
				else (X2.right[k]).RemoveInTheList(pY);
				pY = (bondbox*) (X.right[k]).GetNext ();
			}
		}
	}
}

