#include "dynList.h"
#include <iostream>
using namespace std;
/*******************************************************************************/
TListe::TListe () {First = NULL; Current = NULL; Last =NULL;}
//-------------------------------------------------------------
TListe::TListe (TListe &list)
{	if (&list == this) return;
	DeleteAll (false);
	if (list.GetFirst()==NULL) return;
	void *vpt = list.GetFirst ();
	do  {   Push (vpt);
		    vpt = list.GetNext ();
	    }
	while (vpt != NULL);
}
//-------------------------------------------------------------
TListe::~TListe ()
{	Current = First;
	while (First != NULL)	RemoveCurrent (false);
}
//-------------------------------------------------------------
void TListe::operator= (TListe& list)
{	if (this == &list) return;
	DeleteAll (false);
	if (list.GetFirst () == NULL) return;
	void *vpt = list.GetFirst ();
	do	{	Push (vpt);
		    vpt = list.GetNext ();
	    }
	while (vpt != NULL);
}
//-------------------------------------------------------------
bool TListe::IsEmpty (void)
{	return (First==NULL);
}
//-------------------------------------------------------------
LTYPE* TListe::GetCurrent (void)
{	if (Current == NULL) return NULL;
	return Current->Object;
}
//-------------------------------------------------------------
LTYPE* TListe::GetFirst (void)
{	Current = First;
	if (Current == NULL) return NULL;
	return Current->Object;
}
//-------------------------------------------------------------
LTYPE* TListe::GetLast (void)
{	Current = Last;
	if (Current == NULL) return NULL;
	return Current->Object;
}
//-------------------------------------------------------------
LTYPE* TListe::GetNext (void)
{	if (Current==NULL) return NULL;
	Current = Current->Next;
	if (Current == NULL) return NULL;
	return Current->Object;
}
//-------------------------------------------------------------
LTYPE* TListe::GetPrev (void)
{	if (Current==NULL) return NULL;
	Current = Current->Prev;
	if (Current == NULL) return NULL;
	return Current->Object;
}
//-------------------------------------------------------------
void TListe::Push (LTYPE* obj) //Remplace Add
{	//Insere un element en debut de liste
	TElt *pt = new TElt;
	pt->Object = obj;
	if (First == NULL)
	{First = pt;Last=pt;pt->Next = NULL;pt->Prev = NULL;}
	else
	{	pt->Prev = NULL;
		First->Prev = pt;
		pt->Next = First;
		First=pt;
	}
	Current = pt;
}
//-------------------------------------------------------------
void TListe::Insert (LTYPE* obj)
{	//Insere un element juste avant l'element courant
	if (First == NULL)	Push(obj);
	else
	{	if (Current == NULL) return;
		TElt *pt = new TElt;
		pt->Object = obj;
		if (Current->Prev==NULL) {First= pt;pt->Prev = NULL;}
		else	{(Current->Prev)->Next = pt;pt->Prev = Current->Prev;}
		Current->Prev = pt;	pt->Next = Current;
	}
}
//-------------------------------------------------------------
LTYPE* TListe::Pull (void)  
{
    LTYPE* r=GetLast();
    RemoveCurrent(false);
    return r;
}
//-------------------------------------------------------------
void TListe::RemoveCurrent(bool withelement)
{	if (Current == NULL) return;
	if (withelement) delete Current->Object;
	TElt* aux = Current;
	if (Current == First) First=First->Next;
	else (Current->Prev)->Next = Current->Next;
    if (Current==Last) Last=Last->Prev;
    else (Current->Next)->Prev = Current->Prev;
	Current = Current->Next;
	delete aux;
}
//-------------------------------------------------------------
void TListe::DeleteAll (bool withelement)
{	Current = First;
	while (First != NULL)	RemoveCurrent(withelement);
}
//-------------------------------------------------------------
void TListe::RemoveInTheList (LTYPE* obj)
{   int OK=0;
	LTYPE *pobj = GetFirst ();
	do
	{	if (pobj == obj)
		{	OK=1;
			RemoveCurrent(false);
			if (Current == NULL) pobj=NULL;
			else pobj = Current->Object;
		}
		else pobj = GetNext ();
	}
	while (pobj != NULL);
	if (OK==0) cout<<"\n ------>>> ERREUR Remove \n";
}

