#include "widgetCameleon.h"
#include<QMouseEvent>

double X,Theta;//Pour recuperer les coordoonnees de la souris dans l'espace de configuration(widgetCameleon afin de dessiner le robot dans widgetrobot correspondant
bool cobweb = false;
bool smoothpath=true;
bool DisplayMotion=false;
list<box> path; // Liste contenant tous les boites du chemin faisable entre A et B
box V;
bondbox P0;//Domaine initiale
widgetCameleon::widgetCameleon(QWidget *parent) : QWidget(parent)
{
        pA=NULL; pB=NULL;
        priorBox=box(2);
        priorBox[1]= interval(-28,57);
        priorBox[2]= interval(-1.4,2.7);
        V=box(2);
        V[1]=1; V[2]=10;
        P0[1]= interval(-28,57);
        P0[2]= interval(-1.4,2.7);
}

void widgetCameleon::clear()
{
    path.clear();
    update();
}
//---------------------------------------------------------------------------
void widgetCameleon::Clean(QPaintEvent *)
{
   QPainter painter(this);
   painter.setPen(QPen(QColor(Qt::white)));
   painter.fillRect(QRectF(0, 0, width() - 1, height() - 1),QColor(Qt::white));
}
void widgetCameleon::nettoyerImage(QPainter *painterImage)
{
   painterImage->setPen(QPen(QColor(Qt::white)));
   painterImage->fillRect(QRectF(0, 0, width() - 1, height() - 1),QColor(Qt::white));
}
//-------------------------------------------------------------------------------------
void widgetCameleon::paintEvent(QPaintEvent *)
{
    QPainter widgetPainter(this);
    widgetPainter.drawImage(0, 0, image1);
    widgetPainter.setPen(QPen(QColor(Qt::red)));
    widgetPainter.drawRect(QRectF(0, 0, width() - 1, height() - 1));
}
//---------------------------------------------------------------------------------------
void widgetCameleon:: drawMotion()
{
    QPainter painter1(&image1);
    DrawMotion (path,priorBox,Qt::darkMagenta,&image1,&painter1);
    repaint();
}
//---------------------------------------------------------------------------------------
void widgetCameleon::pathSiviaStart()
{
    image1=QImage(QSize(width(),height()), QImage::Format_ARGB32_Premultiplied);
    QPainter imagePainter(&image1);
    clear();
    nettoyerImage(&imagePainter);
    repaint();
    Sivia(P0,path,&image1,&imagePainter);
    repaint();
}
//----------------------------------------------------------------------------------------
void widgetCameleon::cameleonStart()
{
    image1=QImage(QSize(width(),height()), QImage::Format_ARGB32_Premultiplied);
    QPainter imagePainter(&image1);
    clear();
    repaint();
    Cameleon(P0,path,&image1,&imagePainter);
    repaint();
}
//-----------------------------------------------------------------------------------------
void widgetCameleon:: drawAetB()
{
    image1=QImage(QSize(width(),height()), QImage::Format_ARGB32_Premultiplied);
    QPainter painterImage(&image1);
    QPen pen(Qt::red);
    pen.setWidth(7);
    painterImage.setPen(pen);
    QPoint O1(xToPix(0,priorBox,&image1),yToPix(0,priorBox,&image1));
    QPoint O2(xToPix(17,priorBox,&image1),yToPix(0,priorBox,&image1));
    QPoint A(xToPix(-1,priorBox,&image1),yToPix(-3.14/20,priorBox,&image1));
    QPoint B(xToPix(17,priorBox,&image1),yToPix(-3.14/20,priorBox,&image1));
    painterImage.drawText(A,"A");
    painterImage.drawText(B,"B");
    painterImage.drawPoint(O1);
    painterImage.drawPoint(O2);
    repaint();
}
//--------------------------------------------------------------------------------------------

void widgetCameleon::mouseMoveEvent(QMouseEvent *event)
{
   double x = event->x();//Recuperer les coordonnees de la souris dans widgetCameleon
   double y = event->y();

   double echx = width()/Width(priorBox[1]);//Pixel to X
   double echy = height()/Width(priorBox[2]);//Pixel to Theta
   X= ((double)x/echx)+priorBox[1].inf;
   Theta= priorBox[2].inf+((double)(height()-y)/echy);
   toWRobot();//Signal vers widgetrobot pour dessiner le robot correspondant a cette position
}


//************************Algorithmes*****************************//
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

 void widgetCameleon::DrawPath (bondbox* pB,box& priorbox,list<box>& chemin,QImage *image,QPainter *painter)
 {
     //Dessine le chemin de B  A (A n'a pas de passeur)
     QPen thickPen(palette().foreground(), 3);
     painter->setPen(thickPen);

     if (pB!=NULL)
         {	if (pB->passeur!=NULL)
                 {	double x1,x2,y1,y2;
                         x1=Center((*pB)[1]);			y1=Center((*pB)[2]);
                         x2=Center((*(pB->passeur))[1]);	y2=Center((*(pB->passeur))[2]);

                        QPointF p1=QPointF(xToPix(x1,priorbox,image),yToPix(y1,priorbox,image));
                        QPointF p2=QPointF(xToPix(x2,priorbox,image),yToPix(y2,priorbox,image));

                        painter->drawLine(p1,p2);
                        box tmp(2);
                        tmp[1]=(*pB)[1];
                        tmp[2]=(*pB)[2];
                        chemin.push_front(tmp);

                 }

            DrawPath(pB->passeur,priorbox,chemin,image,painter);

            }
 }

 //----------------------------------------------------------------------------------------------------------

void widgetCameleon::DrawMotion (list<box> chemin,box& priorBox,QColor col,QImage *image, QPainter *painterImage)
{   //dessine l'objet en mouvement

    list<box>::iterator i;
    for(i=chemin.begin(); i != chemin.end(); ++i)
    {
                           DrawBox(*i,priorBox,Qt::white,Qt::black,image,painterImage);
                           repaint();
                           DrawBox(*i,priorBox,col,Qt::black,image,painterImage);
                           _sleep(40.0);

    }


}

//---------------------------------------------------------------------

void widgetCameleon::Dijkstra(bondbox* pA,bondbox* pB,int t1,int t2, int col)
{
    //Algo du plus court chemin
    TListe L;
    L.Push(pA);
    bool sortie=false; //Car pB n'a pas ete atteint

    do
    {
        pA = (bondbox*) L.GetLast();
        pA->couleur=col;
        L.RemoveCurrent(false);  //A remplacer par PULL

        for (int k=1;k<=pA->dim;k++) //Pour tous les voisins de *pA
            {
                    bondbox *pY = (bondbox*) (pA->left[k]).GetFirst();

                    while ((pY != NULL)&&(!sortie))
                    {
                        if ((pY->couleur!=col)&&((pY->inside==t1)||(pY->inside==t2)))
                            {
                                    pY->couleur=col;
                                    pY->passeur=pA;
                                    L.Push(pY);
                                    if (pY==pB) sortie=true;
                            }
                          pY = (bondbox*) (pA->left[k]).GetNext ();
                        }
                    pY = (bondbox*) (pA->right[k]).GetFirst();

                    while ((pY != NULL)&&(!sortie))
                    {
                        if ((pY->couleur!=col)&&((pY->inside==t1)||(pY->inside==t2)))
                            {
                                    pY->couleur=col;
                                    pY->passeur=pA;
                                    L.Push(pY);
                                    if (pY==pB) sortie=true;
                             }
                           pY = (bondbox*) (pA->right[k]).GetNext ();
                    }
        }
        } while ((!L.IsEmpty())&&(!sortie));
    if (!L.IsEmpty()) L.DeleteAll(false);
}
//----------------------------------------------------------------------------------------------------------
void widgetCameleon::DrawCobweb(TListe& L,box& priorbox,QColor couleur,QImage *image, QPainter *painterImage)
{       int m=0;
        DrawBox(priorbox,priorbox,Qt::black,Qt::black,image,painterImage);
        painterImage->setPen(QPen(couleur));
        bondbox *pY = (bondbox*) L.GetFirst();
        while (pY != NULL)
        {	bondbox* pZ = (bondbox*) pY->passeur;
                if (pZ!=NULL)
                { m++;
                  QPointF N(xToPix(Center((*pY)[1]),priorbox,image),yToPix(Center((*pY)[2]),priorbox,image));
                  QPointF M(xToPix(Center((*pZ)[1]),priorbox,image),yToPix(Center((*pZ)[2]),priorbox,image));
                  painterImage->drawLine(N,M);
                  if(m%15==0)repaint();
                }

                pY = (bondbox*) L.GetNext ();

        }
}

//---------------------------------------------------------------------
iboolean widgetCameleon:: InRobot(box& A)
{  //Test si le pav A (de dimension 2) touche ou non les obstacles
   box s0(2);box s1(2);
   int imax=sx.size()-1;
   for (int i=0;i<=imax-1;i++)

   {   s0[1]=sx[i];   s0[2]=sy[i]; s1[1]=sx[i+1]; s1[2]=sy[i+1];
       box s1_0=s0-s1;
       box s0_A=s0-A;
      // interval d=Determinant(s0-s1,s0-A);
       interval d=Determinant(s1_0,s0_A);
       if ((In(0,d)) && (!Disjoint(A,Union(s0,s1)))) return iperhaps;
   }
   box a=Center(A);
   double total=0;
   double alpha;
   for (int i=0; i<=imax-1; i++)
   {  s0[1]=sx[i];   s0[2]=sy[i]; s1[1]=sx[i+1]; s1[2]=sy[i+1];
       box s0_a=box(2);
       s0_a= s0-a;
       box s1_a=box(2);
       s1_a=s1-a;
      alpha=Angle(s0-a,s1-a);
      // alpha=Angle(s0_a,s1_a);
      total=total + alpha;
   }
   if ((total>1)||(total<-1))  return itrue;
   return ifalse;
}
//---------------------------------------------------------------------
iboolean widgetCameleon:: Inside(bondbox &P)   // Test si le pav P (de dimension 3) est ou n'est pas dans
                              // l'ensemble des configs admissibles
{   interval P1=P[1];    interval P2=P[2];
    vector<interval> Ax,Ay,Bx,By;
    double p2c=Center(P2);
    double p1c=Center(P1);
    interval CosP2=Cos(P2);
    double cosp2=cos(p2c);
    interval SinP2=Sin(P2);
    double sinp2=sin(p2c);
    iboolean result=itrue;
    for (int j=0;j<=jmax-1;j++) //pour chaque primitive
    {   //on calcule les coordonnes de A1, B1, A2 et B2 (obstacles) dans le repere de l'objet,
        box A=box(2);
        box B=box(2);
        A[1]= CosP2*(ax[j]-P1) + SinP2*(ay[j]);
        double fc=cosp2*(ax[j]-p1c) + sinp2*(ay[j]);      //Les 5 lignes qui suivent diminue le pessimisme
        interval df1=-CosP2;                            //pour A[1] en utilisant la forme centre
        interval df2= -(ax[j]-P1)*SinP2+CosP2*(ay[j]);  // Idem pour A[2], B[1] et B[2]
        interval A1c=fc+df1*(P1-p1c)+df2*(P2-p2c);
        A[1]=Inter(A[1],A1c);
        //
        A[2]=-SinP2*(ax[j]-P1) + CosP2*(ay[j]);
        fc=-sinp2*(ax[j]-p1c) + cosp2*(ay[j]);
        df1=SinP2;
        df2= -(ax[j]-P1)*CosP2-SinP2*(ay[j]);
        interval A2c=fc+df1*(P1-p1c)+df2*(P2-p2c);
        A[2]=Inter(A[2],A2c);
        //
        B[1]= CosP2*(bx[j]-P1) + SinP2*(by[j]);
        fc=cosp2*(bx[j]-p1c) + sinp2*(by[j]);
        df1=-CosP2;
        df2= -(bx[j]-P1)*SinP2+CosP2*(by[j]);
        interval B1c=fc+df1*(P1-p1c)+df2*(P2-p2c);
        B[1]=Inter(B[1],B1c);
        //
        B[2]=-SinP2*(bx[j]-P1) + CosP2*(by[j]);
        fc=-sinp2*(bx[j]-p1c) + cosp2*(by[j]);
        df1=SinP2;
        df2= -(bx[j]-P1)*CosP2-SinP2*(by[j]);
        interval B2c=fc+df1*(P1-p1c)+df2*(P2-p2c);
        B[2]=Inter(B[2],B2c);

        if (InRobot(A)==true) return ifalse;
        if (InRobot(B)==true) return ifalse;
        for (int i=0;i<=imax-1;i++)
        {   //a[j]b[j] coupe le segment du robot, on rejete la configuration
            box s0 =box(2);    s0[1]=sx[i];   s0[2]=sy[i];
            box s1=box(2);     s1[1]=sx[i+1]; s1[2]=sy[i+1];
            box ds=box(2); ds=s1-s0;            box B_s1=box(2);B_s1=B-s1;
            interval d1=Determinant(B-s1,A-s1)*Determinant(B-s0,A-s0);
            interval d2=Determinant(ds,s1-A)*Determinant(ds,s1-B);
            if ((Sup(d1)<=0)&&(Sup(d2)<=0)) return ifalse; // FullCoupure
            bool fullDisjoint=Disjoint(Union(A,B),Union(s0,s1));
            if ((Inf(d1)<=0)&&(Inf(d2)<=0)&&(!fullDisjoint)) result=iperhaps;
        }
    }
    return result;
}
//---------------------------------------------------------------------------
void SmoothPath(bondbox* pB)  // Dessine un chemin qui arrondi les angles
{	if (pB!=NULL) if (pB->passeur!=NULL)
        if ((pB->passeur->passeur)!=NULL)
        {	if (In(*pB,*(pB->passeur->passeur))!=ifalse)
                        pB->passeur=pB->passeur->passeur;
                SmoothPath(pB->passeur);
        }
}

//---------------------------------------------------------------------
void widgetCameleon::ReseauVersListe(bondbox* pA,TListe &L)
{
        // On constitue une liste contenant tous les elements du reseau
        L.Push(pA);
        pA->couleur=999;
        for (int k=1;k<=pA->dim;k++)
        {
                bondbox *pY = (bondbox*) (pA->left[k]).GetFirst();
                while (pY != NULL)
                {
                    if	(pY->couleur!=pA->couleur)
                    {
                        ReseauVersListe(pY,L);
                    }
                        pY = (bondbox*) (pA->left[k]).GetNext();
                }
                pY = (bondbox*) (pA->right[k]).GetFirst();
                while (pY != NULL)
                {
                    if	(pY->couleur!=pA->couleur)
                    {
                        ReseauVersListe(pY,L);
                    }
                        pY = (bondbox*) (pA->right[k]).GetNext ();
                }
        }
}
//---------------------------------------------------------------------------------------
void widgetCameleon::CleanAll (bondbox* pP)
{ if (pP==NULL) return;
  TListe Ldel;
  ReseauVersListe(pP,Ldel);
  Ldel.DeleteAll(true);
  pA=NULL;
}

//------------------------------------------------------------------------------------------
void widgetCameleon::Sivia (bondbox &P,list<box>& path,QImage *image, QPainter *painter)
{
        int k=0;
        CleanAll (pA);
        pA=NULL;
        pB=NULL;
        TListe L;
        box A(2);A[1]=interval(Ax,Ax);A[2]=interval(Ay,Ay);
        box B(2);B[1]=interval(Bx,Bx);B[2]=interval(By,By);
        bondbox* pP= new bondbox(2);
        *pP=P; L.Push(pP);
     do
        {
                pP = (bondbox*) L.GetLast();
                L.RemoveCurrent(false);
                iboolean test=Inside(*pP);
                if (In(A,*pP)==true) pA=pP;
                if (In(B,*pP)==true) pB=pP;
                if (test==false)
                   {
                        //Box Out
                        pP->inside=-1;
                        DrawBox(*pP,P,Qt::blue,Qt::black,image,painter);
                   }
                else if	(test==true)
                   {
                          //Box IN
                          pP->inside=1;
                          DrawBox(*pP,P,Qt::red,Qt::black,image,painter);
                   }
                else if ((*pP).Width()< 0.1)
                   {
                        //Box Perhaps
                        pP->inside=0;
                        DrawBox(*pP,P,Qt::yellow,Qt::green,image,painter);
                   }
                else
                   {	bondbox* pP1= new bondbox(2);
                        bondbox* pP2= new bondbox(2);
                        Bisect(*pP, *pP1, *pP2,V);
                        L.Push(pP1);L.Push(pP2);

                   }
                 // Incrementation de l'indice k qui copmte le nombre des boxes totales et sert pour l'affichage
                 k++;
                if(k%120==0) repaint();
        }
        while (L.GetFirst()!=NULL);
        repaint();
   Dijkstra(pA,pB,0,1,777);


   if (smoothpath) SmoothPath(pB);
   DrawPath (pB,P,path,image,painter);

   cout << "Sivia To found a feasible path is finished ..."<<endl;
   cout <<"Nombre des boxes avec Sivia : " <<k<<endl;
   cout <<"path.size() avec Sivia : " <<path.size()<<endl;
   cout.flush();

   if (cobweb)
     { TListe L2;
       ReseauVersListe(pP,L2);
       DrawCobweb(L2,P,Qt::white,image,painter);
       L2.DeleteAll(false);
     }

  L.DeleteAll(false);
  CleanAll (pA);
}
//---------------------------------------------------------------------
void widgetCameleon:: Cameleon(bondbox& P,list<box>& path,QImage *image, QPainter *painter)
{

        int k=0; //Indice k qui copmte le nombre des boxes totales et sert pour la mise a jour de l'affichage
        CleanAll (pA);
        QColor lim(173,255,47);
        box A(2);A[1]=interval(Ax,Ax);A[2]=interval(Ay,Ay);
        box B(2);B[1]=interval(Bx,Bx);B[2]=interval(By,By);
        bondbox* pP= new bondbox(2);
        *pP=P; pA=pP; pB=pP; pP->inside=0;
        int l=3;

        do
        {
            Dijkstra(pA,pB,1,1,l++);
            if ((pA->couleur==pB->couleur)&&(pA!=pB)) break; //on a trouve le chemin

            Dijkstra(pA,pB,1,0,l++);
            if (pA->couleur!=pB->couleur) break; //impossible de trouver un chemin

            // On fabrique le path jaune qu'il nous faut creuser
            TListe pathjaune;
            pP=pB;
            do
            {
                pathjaune.Push(pP);
                DrawBox(*pP,P,Qt::green,Qt::blue,image,painter);
                pP=pP->passeur;
            } while (pP!=NULL);

            //On bisecte tous pavs de pathjaune
            do
            {   pP = (bondbox*) pathjaune.GetFirst();
                pathjaune.RemoveCurrent(false);
                if (pP->inside==1)
                {
                    DrawBox(*pP,P,Qt::red,Qt::black,image,painter);
                }
                else
                {   bondbox* pP1= new bondbox(2);
                    bondbox* pP2= new bondbox(2);
                    Bisect(*pP, *pP1, *pP2,V);
                    //delete pP; Si on le garde il y aura une erreur de segmentation

                    // Pout le fils 1

                    iboolean test1=Inside(*pP1);
                    if (In(A,*pP1)==true) pA=pP1;
                    if (In(B,*pP1)==true) pB=pP1;
                    if (test1==false)
                    {
                    DrawBox(*pP1,P,Qt::blue,Qt::darkBlue,image,painter);
                    pP1->inside=-1;
                    }
                    else if	(test1==true)
                    {
                        pP1->inside=1;
                        DrawBox(*pP1,P,Qt::red,Qt::black,image,painter);
                    }
                    else
                    {
                        pP1->inside=0;
                        DrawBox(*pP1,P,Qt::yellow,lim,image,painter);
                    }

                    // Pout le fils 2
                    iboolean test2=Inside(*pP2);
                    if (In(A,*pP2)==true) pA=pP2;
                    if (In(B,*pP2)==true) pB=pP2;
                    if (test2==false)
                    {
                        pP2->inside=-1;
                        DrawBox(*pP2,P,Qt::blue,Qt::darkBlue,image,painter);
                    }
                    else if	(test2==true)
                    {
                        pP2->inside=1;
                        DrawBox(*pP2,P,Qt::red,Qt::black,image,painter);
                    }
                    else
                    {
                        pP2->inside=0;
                        DrawBox(*pP2,P,Qt::yellow,lim,image,painter);
                    }
                };
                k++;
                if(k%45==0)    repaint();

            } while(!pathjaune.IsEmpty());
            } while (true);
        repaint();
        if (smoothpath) SmoothPath(pB);
        if (cobweb)
          { TListe L2;
            ReseauVersListe(pP,L2);
            DrawCobweb(L2,P,Qt::white,image,painter);
            L2.DeleteAll(false);
          }
        DrawPath (pB,P,path,image,painter);
        cout << "Cameleon To found a feasible path :is finished "<<endl;
        cout <<"Nombre des boxes avec Cameleon : " <<k<<endl;
        cout.flush();
}

//-----------------------------------------------------------------------------------------------------



