#include "widgetrobot.h"
#include"widgetCameleon.h"

widgetrobot::widgetrobot(QWidget *parent) :  QWidget(parent)
{
        repere=box(2);
        repere[1]=interval(-30,80);
        repere[2]=interval(-30,50);
}

//-----------------------------------------------------------------------------
void widgetrobot::motionRobot (list<box> chemin,QColor col,QImage *image, QPainter *painterImage)
{
            //dessine l'objet en mouvement
            DrawRobot (0.,0.,col,image,painterImage);
            repaint();
            _sleep(500.0);
            list<box>::iterator i;
            for(i=chemin.begin(); i != chemin.end(); ++i)
                {
                    double xr = Center((*i)[1]);
                    double yr = Center((*i)[2]);
                    _sleep(40.0);
                    DrawRobot (xr,yr,col,image,painterImage);
                    repaint();
                }
            DrawRobot (Bx,0.,col,image,painterImage);
            _sleep(100.0);
            repaint();
}
//--------------------------------------------------------------------------------------------------------
void widgetrobot::drawRobot()
{
   //Pour dessiner le robot a X, Theta recuperees par le mouvement de la souris
   image2=QImage(QSize(width(),height()), QImage::Format_ARGB32_Premultiplied);
   QPainter imagePainter(&image2);
   DrawRobot(X,Theta,Qt::black,&image2,&imagePainter);
   repaint();
}
//-------------------------------------------------------------------------------------------------
void widgetrobot::drawPath()
{
   image2=QImage(QSize(width(),height()), QImage::Format_ARGB32_Premultiplied);
   QPainter imagePainter(&image2);
   motionRobot (path,Qt::red,&image2, &imagePainter);
   repaint();

}
//--------------------------------------------------------------------------------------------------
void widgetrobot::displayMotion()
{
   image2=QImage(QSize(width(),height()), QImage::Format_ARGB32_Premultiplied);
   QPainter imagePainter(&image2);
   imagePainter.setPen(QPen(QColor(Qt::white)));
   imagePainter.fillRect(QRectF(0, 0, image2.width()- 1, image2.height() - 1),QColor(Qt::white));
   DisplayMotion=true;
   motionRobot (path,Qt::green,&image2, &imagePainter);

   imagePainter.drawText(QPoint(20,40)," The two segment obstacles are still visible");
   DisplayMotion=false;
   repaint();

}
//-----------------------------------------------------------------------------------------------------
void widgetrobot::paintEvent(QPaintEvent *)
{
    QPainter widgetPainter(this);
    widgetPainter.drawImage(0, 0, image2);
    widgetPainter.setPen(QPen(QColor(Qt::red)));
    widgetPainter.drawRect(QRectF(0, 0, width() - 1, height() - 1));
}
//------------------------------------------------------------------------------------------------------
//*** Pour une config (x,y,theta) dessine l'objet associ et les obstacles ***//
void widgetrobot:: DrawRobot (double x, double theta,QColor col,QImage *image,QPainter *painterImage)
{
    if(!DisplayMotion)
    {
    painterImage->setPen(QPen(QColor(Qt::white)));
    painterImage->fillRect(QRectF(0, 0, image->width()- 1, image->height() - 1),QColor(Qt::white));
    }
    QPen thickPen(palette().foreground(), 2);
    painterImage->setPen(thickPen);
    for (int j=0;j<=ax.size()-1;j++)
    {

       QPoint E(xToPix(ax[j],repere,image),yToPix(ay[j],repere,image));
       QPoint F(xToPix(bx[j],repere,image),yToPix(by[j],repere,image));
       painterImage->drawLine(E,F);
    }
    vector<double> xa,ya;
    QVector<QPoint> points;
    double tmp1, tmp2, xr,yr;
    for (int i=0;i<=sx.size()-1;i++)
    {
         xr=sx[i];
         yr=sy[i];
         tmp1=x+xr*cos(theta)-yr*sin(theta);
         tmp2=0+xr*sin(theta)+yr*cos(theta);
        xa.push_back(tmp1);
        ya.push_back(tmp2);
        QPoint H(xToPix(tmp1,repere,image),yToPix(tmp2,repere,image));
        points.push_back(H);
    }

   painterImage->setPen(QPen(col));
   QPolygon polygone(points);
   painterImage->drawPolygon(polygone);

    thickPen=QPen(palette().foreground(), 7);
    painterImage->setPen(thickPen);
    QPoint O(xToPix(xa[0],repere,image),yToPix(ya[0],repere,image));
    painterImage->drawPoint(O);

    thickPen=QPen(palette().foreground(), 3);
    painterImage->setPen(thickPen);
    QPoint l1(xToPix(-50,repere,image),yToPix(0,repere,image));
    QPoint l2(xToPix(100,repere,image),yToPix(0,repere,image));
    painterImage->drawLine(l1,l2);
    painterImage->setPen(QPen(Qt::black));


    QPen pen(Qt::red);
    pen.setWidth(7);
    painterImage->setPen(pen);
    QPoint O1(xToPix(0,repere,image),yToPix(0,repere,image));
    QPoint O2(xToPix(17,repere,image),yToPix(0,repere,image));
    QPoint A(xToPix(0,repere,image),yToPix(-4,repere,image));
    QPoint B(xToPix(17,repere,image),yToPix(-4,repere,image));
    painterImage->drawText(A,"A");
    painterImage->drawText(B,"B");
    painterImage->drawPoint(O1);
    painterImage->drawPoint(O2);
}

